//+------------------------------------------------------------------+
//|   EOD.MQ4                                               test.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_color4 Blue

#define	LONG         1
#define	SHORT        -1
#define	FLAT         0



//---- buffers
double UpBuf[];
double DownBuf[];
double HighSwingBuf[];
double LowSwingBuf[];

int   GuppyHistTrend;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY,1);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, UpBuf);
   SetIndexStyle(1, DRAW_ARROW, EMPTY,1);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, DownBuf);
   SetIndexBuffer(2, HighSwingBuf);
   SetIndexStyle(2, DRAW_ARROW, EMPTY,2,Red);
   SetIndexArrow(2, 159);
   SetIndexBuffer(3, LowSwingBuf);
   SetIndexStyle(3, DRAW_ARROW, EMPTY,2,Blue);
    SetIndexArrow(3, 159);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int GuppyHist;
   double HAO,HAC;
   bool HA_UP,AO_UP;
   double up,dn,slope,GuppyW,GuppyEdge,AO,AOp,AOpp, ATR_UP,ATR_DN,ATR_MID,Gann,Gannp,Gannpp,PSar;
//----
   
   if (counted_bars>0) counted_bars--;
   int    limit=Bars-counted_bars;
   
     for(int i=0;i<limit;i++)
   {


double CCI=iCCI(NULL,0,40,PRICE_TYPICAL,i);
double CCI2=iCCI(NULL,0,40,PRICE_TYPICAL,i+1);
double ST1=iStochastic(NULL,0,5,3,2,MODE_SMA,0,MODE_MAIN,i);
double ST2=iStochastic(NULL,0,5,3,2,MODE_SMA,0,MODE_MAIN,i+1);
double ST3=iStochastic(NULL,0,5,3,2,MODE_SMA,0,MODE_MAIN,i+2);
double ST4=iStochastic(NULL,0,5,3,2,MODE_SMA,0,MODE_MAIN,i+3);


//HAO=iCustom(NULL,0,"Heiken Ashi",2,i);
//HAC=iCustom(NULL,0,"Heiken Ashi",3,i);
//Print(HAO);

//ATR_UP=iCustom(NULL,0,"ATR_Channel",0,i);
//ATR_DN=iCustom(NULL,0,"ATR_Channel",1,i);
//ATR_MID=iCustom(NULL,0,"ATR_Channel",2,i);

//AO=iMACD(NULL,0,5,34,5,PRICE_CLOSE,MODE_MAIN,i);
//AOp=iMACD(NULL,0,5,34,5,PRICE_CLOSE,MODE_MAIN,i+1);
//AOpp=iMACD(NULL,0,5,34,5,PRICE_CLOSE,MODE_MAIN,i+2);

//Gann=iCustom(NULL,0,"###Gann_HiLo_Activator_v2###",10,0,i);
//Gannp=iCustom(NULL,0,"###Gann_HiLo_Activator_v2###",10,0,i+1);
//Gannpp=iCustom(NULL,0,"###Gann_HiLo_Activator_v2###",10,0,i+2);
//PSar=iSAR(NULL,0,0.02,0.2,i);

//if (AO>AOp){AO_UP=true;} else AO_UP=false;

   

   if ((CCI<0 && ST1<ST2 && ST2>=ST3 && ST2>50 && Close[i]<Open[i]) || (CCI<0 && CCI2<0 && ST2<ST3 && ST3>=ST4 && ST3>50 && Close[i]<Open[i] && Close[i+1]>Open[i+1]))
      {
      DownBuf[i] = Low[i] -Point*50; UpBuf[i] =EMPTY_VALUE;
      int lsh=LastSwingHigh(i);
      HighSwingBuf[i]=High[lsh];
      } else 
      {
      DownBuf[i] = EMPTY_VALUE;
      lsh=LastSwingHigh(i);
     // HighSwingBuf[i]=EMPTY_VALUE;
      }
      
   if ((CCI>0 && ST1>ST2 && ST2<=ST3 && ST2<50 && Close[i]>Open[i]) || (CCI>0 && CCI2>0 && ST2>ST3 && ST3<=ST4 && ST3<50 && Close[i]>Open[i] && Close[i+1]<Open[i+1]) )
      {
      UpBuf[i] = High[i] +Point*50; DownBuf[i] =EMPTY_VALUE;
      int lsl=LastSwingLow(i);
      LowSwingBuf[i]=Low[lsl];
      } else
       {
       UpBuf[i] = EMPTY_VALUE;
       lsl=LastSwingLow(i);
    //  LowSwingBuf[i]=EMPTY_VALUE;
       }
   
   
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+


int LastSwingLow(int st)
{
double swing=st;
for (int i=st; i<=Bars; i++)
if(Low[i+1]>Low[i]){swing=i; break;}
return(swing);
}

int LastSwingHigh(int st)
{
double swing=st;
for (int i=st; i<=Bars; i++)
if(High[i+1]<High[i]){swing=i; break;}
return(swing);
}