//+------------------------------------------------------------------+
//|                                                 Range_Trader.mq4 |
//|                                         Copyright  2008,JP      |
//|                                      maurosandrade@yahoo.com.br  |
//| made for BELEKAS and Igroks Thread                               |
//| modified for use with the Igrok Method             |
//+------------------------------------------------------------------+
//| Range_Trader_TRO_MODIFIED_VERSION                                |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author                                     |
//  and I am not claiming authorship of this indicator.              |
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+


#property copyright "Copyright  2008, Jupiter_Peak"
#property link      "maurosandrade@yahoo.com.br"

#property indicator_chart_window

extern int myChartX   = 350 ;
extern int myChartY   = 100 ;
extern int myCorner   = 0 ;
extern string myFont  = "Courier New" ;
extern int myFontSize = 12 ;
extern color colorHD = DarkGray ;

extern double    Risk_to_Reward_ratio= 5.0;
extern int       Stop_Loss= 1;

extern bool      SkipSundays = true;


extern bool  Plot.Lines = true ;
 
extern int    Line_Width            = 1 ;
extern int    Line_Style_Long       = STYLE_DASH ;
extern color  Line_Color_ENT_Long   = Blue ;
extern color  Line_Color_SL_Long    = Red ;
extern color  Line_Color_TP_Long    = Green ;

extern int    Line_Style_Short      = STYLE_DOT ;
extern color  Line_Color_ENT_Short  = Maroon ;
extern color  Line_Color_SL_Short   = Navy ;
extern color  Line_Color_TP_Short   = Green ;

string symbol, tChartPeriod, ShortName ;  
string lbl[15], lbl2[15];
int n, j, i ;


int    digits, period  ; 
double point ;
 
//+------------------------------------------------------------------+
int init()
{
   symbol       =  Symbol() ;  
   digits       =  Digits ;
   point        =  Point ;
   ShortName    =  "TRORT"+symbol  ;
   
       
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }  
   
   return(0);
}

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
//+------------------------------------------------------------------+
int deinit()
  {
 
   Comment( "" );
   ObDeleteObjectsByPrefix("TRORT");     
 
   return(0);
  } 
  
//+------------------------------------------------------------------+
int start()
  {
  


   //----
   string PIPS="";
   int R1=0,MR25=0,WR25=0,R25=0,R40=0,RAvg=0;
   int Prevday=0,Prevwk=0,Prevmthy=0;
   int Curday=0,Curwk=0,Curmthy=0,CurrentSpread=0;
   int EntryLong=0,EntryShort=0,StopLoss_Long=0,StopLoss_Short=0,today_range=0,RoomDown=0,TPLong=0,TPShort=0,TotalPips=0;
   double   SL_Long=0,SL_Short=0,ENT_Long=0,ENT_Short,TP_Long=0,TP_Short=0;
   double   low0=0,high0=0, low1=0,high1=0;
   string   Text="";
   int i=0;
   double OPEN = iOpen(NULL,1440,0);
   double CLOSE = iClose(NULL,1440,0);
   PIPS =  DoubleToStr((CLOSE-OPEN)/point,0);
      
   R1 =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/point;
   
   for(i=1;i<=60;i++)
      R25   =    R25 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/point;
   for(i=1;i<=26;i++)
      WR25   =    WR25 +  (iHigh(NULL,PERIOD_W1,i)-iLow(NULL,PERIOD_W1,i))/point;
   for(i=1;i<=24;i++)
      MR25   =    MR25 +  (iHigh(NULL,PERIOD_MN1,i)-iLow(NULL,PERIOD_MN1,i))/point;

Prevday =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/point;
Prevwk =  (iHigh(NULL,PERIOD_W1,1)-iLow(NULL,PERIOD_W1,1))/point;
Prevmthy =  (iHigh(NULL,PERIOD_MN1,1)-iLow(NULL,PERIOD_MN1,1))/point;

Curday =  (iHigh(NULL,PERIOD_D1,0)-iLow(NULL,PERIOD_D1,0))/point;
Curwk =  (iHigh(NULL,PERIOD_W1,0)-iLow(NULL,PERIOD_W1,0))/point;
Curmthy = (iHigh(NULL,PERIOD_MN1,0)-iLow(NULL,PERIOD_MN1,0))/point;


   int dayshift = 1;
   if( SkipSundays && TimeDayOfWeek( iTime(NULL, PERIOD_D1, 0 ) ) == 1 ) dayshift = 2; //monday
   low1  =  iLow(NULL,PERIOD_D1,dayshift);
   high1 =  iHigh(NULL,PERIOD_D1,dayshift);
   
   int numbarsM1today = iBarShift( NULL, PERIOD_M1, iTime(NULL, PERIOD_D1, 0 ));
   bool mainMoveRange = true;
   bool mainMoveUp = false;
   for( int k=numbarsM1today;k>=0;k-- )
   if( iLow(NULL, PERIOD_M1, k ) < low1 ) { mainMoveRange = false; mainMoveUp = false; break; }
   else
   if( iHigh(NULL, PERIOD_M1, k ) > high1 ) { mainMoveRange = false; mainMoveUp = true; break; }
   string dayMove = "Main move of the day is ";
   if( mainMoveRange == true ) dayMove = dayMove + "RANGING"; else
   if( mainMoveUp == true ) dayMove = dayMove + "UP"; else dayMove = dayMove + "DOWN";   
      
   R25 = R25/60;
   WR25 = WR25/26;
   MR25 = MR25/24;
   
   low0  =  iLow(NULL,PERIOD_D1,0);
   high0 =  iHigh(NULL,PERIOD_D1,0);
   TotalPips = R25/Risk_to_Reward_ratio;
   EntryLong = TotalPips - Stop_Loss;
   ENT_Long = low0 + EntryLong*point;
   SL_Long    =  low0 - Stop_Loss*point;
   TPLong =  EntryLong + R25; 
   TP_Long = ENT_Long + TPLong*point;
   EntryShort =  TotalPips - Stop_Loss;
   ENT_Short  =  high0 - EntryShort*point;
   SL_Short   =  high0 + Stop_Loss*point;
   TPShort = R25 + high0 - EntryShort;
   TP_Short = ENT_Short - TPShort*point;
   
   CurrentSpread = (Ask/ point)-(Bid/ point);

   today_range = (iHigh(NULL,PERIOD_D1,0)) - (iLow(NULL,PERIOD_D1,0));

   Text =  
   
   // "RangeTrader - Originally coded by maurosandrade" + "\n" +
   //         "Modified by TheRumpledOne" + "\n\n" +          
            "Avg 60 Days Range: " +  R25  + "\n" +
            "Prev Day Range: " +  Prevday  + "\n" +
            "Current Day Range: " +  Curday  + "\n\n" +
            "Avg 26 Weeks Range: " +  WR25  + "\n" +
            "Prev Week Range: " +  Prevwk  + "\n" +
            "Current Week Range: " +  Curwk  + "\n\n" +
            "Avg 24 Months Range: " +  MR25  + "\n" +
            "Prev Month Range: " +  Prevmthy  + "\n" +
            "Current Month Range: " +  Curmthy  + "\n" +
            "Currency Pair spread: " +  CurrentSpread  + "\n" +
            dayMove + "\n\n";
            //"Today Range: " +  today_range  + "\n";
            
   Text =   Text +
            "Long Entry: " + EntryLong + " Pips at " + DoubleToStr(ENT_Long,digits)  + "\n" +        
            "Short Entry: " + EntryShort + " Pips at " + DoubleToStr(ENT_Short,digits)  + "\n\n" +
            "StopLosses should be :"  + "\n" +
            "Long:  " + Stop_Loss  + " Pips at " + DoubleToStr(SL_Long,digits)  + "\n" +
            "Short: " + Stop_Loss + " Pips at " + DoubleToStr(SL_Short,digits) + "\n\n" +
            "Take Profits should be :"  + "\n" +
            "Long:  " + TPLong  + " Pips at " + DoubleToStr(TP_Long,digits)  + "\n" +
            "Short: " + TPShort + " Pips at " + DoubleToStr(TP_Short,digits) + "\n\n" +
            "** Always Consider Spread on Pair Before Entering **" + "\n\n" ;
              
            
  
   Comment(Text);



   
   
   
if(Plot.Lines)
{   
n       = 10;
j       = 0 ;
 
lbl[j]  = ShortName+j;
drawLine(ENT_Long ,lbl[j], Line_Color_ENT_Long , Line_Style_Long ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(SL_Long ,lbl[j], Line_Color_SL_Long , Line_Style_Long ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(TP_Long ,lbl[j], Line_Color_TP_Long , Line_Style_Long ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(ENT_Short ,lbl[j], Line_Color_ENT_Short , Line_Style_Short  ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(SL_Short ,lbl[j], Line_Color_SL_Short , Line_Style_Short  ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(TP_Short ,lbl[j], Line_Color_TP_Short , Line_Style_Short  ) ;
}


return(0);
}


//+------------------------------------------------------------------+
  
void DoShow( int u, color dsColor )
{

 

ObjectCreate(lbl[u],23,0,Time[0],PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE, myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],myFontSize,myFont,dsColor);
 

n = n+20;

   return(0);
  }  
//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            

            ObjectSet(name, OBJPROP_STYLE, type);

            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,Line_Width);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            ObjectSet(name, OBJPROP_STYLE, type);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,Line_Width);
          
         }
 
}
 
//+------------------------------------------------------------------+ 