//+------------------------------------------------------------------+ 
//|   TRO_TrafficLightHA                                             | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 
#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 

//---- indicator settings 
#property indicator_chart_window
#property indicator_buffers 0
#property indicator_minimum 0
#property indicator_maximum 1



//---- indicator parameters  
 

extern int win = 0;
extern int price.x.offset= 0 ; 
extern int price.y.offset= 200 ; 


extern int   myFontSize       = 20;

extern int   myPeriod  = 0;
 


extern color LG_color = Turquoise;
extern color NA_color = DimGray;
extern color SH_color = Magenta;

extern int MaMetod  = 0;
extern int MaPeriod = 1;
extern int MaMetod2  = 3;
extern int MaPeriod2 = 2;
 
string tMessage ;

//+--------- TRO MODIFICATION ---------------------------------------+ 
string symbol, tChartPeriod,  tShortName, oldmsg = "" ;  
int    digits, period  ; 

datetime Trigger ;

int OldBars = -1, TradeBars = 0 ;

color tColor = Yellow ;
color HighColor, LowColor, MidColor, Mid1Color, CloseColor, ClOpColor;
string sIB3531 ; 
 
//+------------------------------------------------------------------+ 
int init() 
  { 
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }    
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   

   tShortName = "TRAFFIC"+ symbol   ;

   tMessage  = " WAIT TRAFFIC LIGHT" ;

   ClOpColor = NA_color ;

   sIB3531 = "TRAF3531" ;

   return(0); 
  } 

//+------------------------------------------------------------------+
int deinit() 
{    

   ObjectDelete(sIB3531);

}  
 
//+------------------------------------------------------------------+ 
int start() 
{ 

double CCI15min = iCCI(NULL, 15, 8, PRICE_TYPICAL, 0);

bool LgCCI15Direction = false;
bool ShCCI15Direction = false;

if(CCI15min > 0) LgCCI15Direction = true;
if(CCI15min < 0) ShCCI15Direction = true;

bool  LgHeikenAshi5Direction = false;
bool  ShHeikenAshi5Direction = false;

double haOpen = iCustom(NULL, 0, "Heiken_Ashi_Smoothed", MaMetod, MaPeriod, MaMetod2, MaPeriod2, 2,  0);
double haClose = iCustom(NULL, 0, "Heiken_Ashi_Smoothed", MaMetod, MaPeriod, MaMetod2, MaPeriod2, 3,  0);

double haOpen1 = iCustom(NULL, 0, "Heiken_Ashi_Smoothed", MaMetod, MaPeriod, MaMetod2, MaPeriod2, 2,  1);
double haClose1 = iCustom(NULL, 0, "Heiken_Ashi_Smoothed", MaMetod, MaPeriod, MaMetod2, MaPeriod2, 3,  1);

if(haOpen < haClose) LgHeikenAshi5Direction = true;
if(haOpen > haClose) ShHeikenAshi5Direction = true;

bool LgHeikenAshi5Cross = false;
bool ShHeikenAshi5Cross = false;

if(haOpen < haClose && haOpen1 > haClose1) LgHeikenAshi5Cross = true;
if(haOpen > haClose && haOpen1 < haClose1) ShHeikenAshi5Cross = true;


while(true)
{
if( LgCCI15Direction && LgHeikenAshi5Direction && LgHeikenAshi5Cross) 
   { ClOpColor = LG_color ; tMessage =  tChartPeriod+ "TRAFFIC LIGHT Go Long" ;  break ; }
   
if( ShCCI15Direction && ShHeikenAshi5Direction && ShHeikenAshi5Cross) 
   { ClOpColor = SH_color ;  tMessage =  tChartPeriod+ "TRAFFIC LIGHT Go Short" ;  break ; }

tMessage = tChartPeriod+" WAIT TRAFFIC LIGHT"  ; ClOpColor = NA_color ;   
 
break;

} // while

oldmsg =  tMessage ;

//+------------------------------------------------------------------+  
                    
   ObjectCreate(sIB3531, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(sIB3531,tMessage, myFontSize , "Arial Bold", ClOpColor );
   ObjectSet(sIB3531, OBJPROP_CORNER, 0);
   ObjectSet(sIB3531, OBJPROP_XDISTANCE, price.x.offset); 
   ObjectSet(sIB3531, OBJPROP_YDISTANCE, price.y.offset); 


//+------------------------------------------------------------------+        


   WindowRedraw();    
 

   return(0); 
} 

//+------------------------------------------------------------------+

 
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+

 