#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//----
int STPeriod = 13;
//----
double ExtBuffer1[];
double ExtBuffer2[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexBuffer(0, ExtBuffer1);
   SetIndexStyle(0, DRAW_HISTOGRAM, 0, 1);
//----
   SetIndexBuffer(1, ExtBuffer2);
   SetIndexStyle(1, DRAW_HISTOGRAM, 0, 1);
//----
   IndicatorShortName("Trend Strength");
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int i, limit;
   double ST0,ST1,ST2;
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars; 
//----   
   for(i = 0; i < limit ; i++)
     {
       ST0 = iADX(NULL, 0, STPeriod, PRICE_CLOSE, MODE_MAIN, i);
       ST1 = iADX(NULL, 0, STPeriod, PRICE_CLOSE, MODE_PLUSDI, i);
       ST2 = iADX(NULL, 0, STPeriod, PRICE_CLOSE, MODE_MINUSDI, i);
       //----
       if(ST1 >= ST2)
         {
           ExtBuffer1[i] = ST0;
           ExtBuffer2[i] = 0;
         }
       else
         {
           ExtBuffer1[i] = 0;
           ExtBuffer2[i] = ST0;
         }
     }
   return(0);
  }
//+------------------------------------------------------------------+