//+------------------------------------------------------------------+
//|                                                   TrendAlert.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

extern int win = 0;
extern int price.x.offset    = 10 ; 
extern int price.y.offset    = 50 ; 
extern int   myFontSize      = 15;
extern string Trade_Message  = "OK TO TRADE" ;
extern string Wait_Message   = "WAIT" ;
 

extern color Trade_color = Orange;
extern color Wait_color  = Yellow;
 
color tColor = Magenta ; 

string tMessage, OBJ0001 ;
 
//+------------------------------------------------------------------+
int init()
  {
 
 OBJ0001 = "TRENDALERT0001" ;
 
   return(0);
  } 
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete(OBJ0001);   
//----
   return(0);
  } 
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   double A, B;
   A=iStdDev(Symbol(),30,20,0,MODE_SMA,PRICE_CLOSE,0);
   B=iStdDev(Symbol(),30,20,0,MODE_SMA,PRICE_CLOSE,1);
 
 
if (A>B) { tMessage = Trade_Message ; tColor = Trade_color ;  }
else     { tMessage = Wait_Message  ; tColor = Wait_color ;  }


   ObjectCreate(OBJ0001, OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText(OBJ0001,tMessage, myFontSize , "Arial Bold", tColor );
   ObjectSet(OBJ0001, OBJPROP_CORNER, 0);
   ObjectSet(OBJ0001, OBJPROP_XDISTANCE, price.x.offset); 
   ObjectSet(OBJ0001, OBJPROP_YDISTANCE, price.y.offset); 

return(0);
}
//+------------------------------------------------------------------+