//+------------------------------------------------------------------+
//|  Multi Time-Frame Trader_TRO_MOD     Multi Time-Frame Trader.mq4 |
//|                                       korostelev.andre@gmail.com |
//|                                                                  |
//+------------------------------------------------------------------+
//http://www.forexfactory.com/showthread.php?p=2570071#post2570071

#property copyright ""
#property link      "korostelev.andre@gmail.com"


#property indicator_chart_window


extern bool trade=true;
extern int barstocount=50;
extern double lots=0.01;
extern int slippage=3;
extern int magicnumber=816;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {

   //M1
   double M1_resistance=iCustom(NULL,PERIOD_M1,"!LinRegrBuf","true",barstocount,2,0);
   double M1_resistance_p=iCustom(NULL,PERIOD_M1,"!LinRegrBuf","true",barstocount,2,barstocount-1);
   double M1_line=iCustom(NULL,PERIOD_M1,"!LinRegrBuf","true",barstocount,0,0);
   double M1_support=iCustom(NULL,PERIOD_M1,"!LinRegrBuf","true",barstocount,1,0);
   double slopeM1=((M1_resistance-M1_resistance_p)/barstocount)/Point; 
   
   //M5
   double M5_resistance=iCustom(NULL,PERIOD_M5,"!LinRegrBuf","true",barstocount,2,0);
   double M5_resistance_p=iCustom(NULL,PERIOD_M5,"!LinRegrBuf","true",barstocount,2,barstocount-1);
   double M5_line=iCustom(NULL,PERIOD_M5,"!LinRegrBuf","true",barstocount,0,0);
   double M5_support=iCustom(NULL,PERIOD_M5,"!LinRegrBuf","true",barstocount,1,0);
   double slopeM5=((M5_resistance-M5_resistance_p)/barstocount)/Point;
   
   //M15
   double M15_resistance=iCustom(NULL,PERIOD_M15,"!LinRegrBuf","true",barstocount,2,0);
   double M15_resistance_p=iCustom(NULL,PERIOD_M15,"!LinRegrBuf","true",barstocount,2,barstocount-1);
   double M15_line=iCustom(NULL,PERIOD_M15,"!LinRegrBuf","true",barstocount,0,0);
   double M15_support=iCustom(NULL,PERIOD_M15,"!LinRegrBuf","true",barstocount,1,0);
   double slopeM15=((M15_resistance-M15_resistance_p)/barstocount)/Point;
   
   //M30
   double M30_resistance=iCustom(NULL,PERIOD_M30,"!LinRegrBuf","true",barstocount,2,0);
   double M30_resistance_p=iCustom(NULL,PERIOD_M30,"!LinRegrBuf","true",barstocount,2,barstocount-1);
   double M30_line=iCustom(NULL,PERIOD_M30,"!LinRegrBuf","true",barstocount,0,0);
   double M30_support=iCustom(NULL,PERIOD_M30,"!LinRegrBuf","true",barstocount,1,0);
   double slopeM30=((M30_resistance-M30_resistance_p)/barstocount)/Point;   
   
   //H1
   double H1_resistance=iCustom(NULL,PERIOD_H1,"!LinRegrBuf","true",barstocount,2,0);
   double H1_resistance_p=iCustom(NULL,PERIOD_H1,"!LinRegrBuf","true",barstocount,2,barstocount-1);
   double H1_line=iCustom(NULL,PERIOD_H1,"!LinRegrBuf","true",barstocount,0,0);
   double H1_support=iCustom(NULL,PERIOD_H1,"!LinRegrBuf","true",barstocount,1,0);
   double slopeH1=((H1_resistance-H1_resistance_p)/barstocount)/Point; 
   
   //H4 
   double H4_resistance=iCustom(NULL,PERIOD_H4,"!LinRegrBuf","true",barstocount,2,0);
   double H4_resistance_p=iCustom(NULL,PERIOD_H4,"!LinRegrBuf","true",barstocount,2,barstocount-1);
   double H4_line=iCustom(NULL,PERIOD_H4,"!LinRegrBuf","true",barstocount,0,0);
   double H4_support=iCustom(NULL,PERIOD_H4,"!LinRegrBuf","true",barstocount,1,0);
   double slopeH4=((H4_resistance-H4_resistance_p)/barstocount)/Point; 
   
   //D1
   double D1_resistance=iCustom(NULL,PERIOD_D1,"!LinRegrBuf","true",barstocount,2,0);
   double D1_resistance_p=iCustom(NULL,PERIOD_D1,"!LinRegrBuf","true",barstocount,2,barstocount-1);
   double D1_line=iCustom(NULL,PERIOD_D1,"!LinRegrBuf","true",barstocount,0,0);
   double D1_support=iCustom(NULL,PERIOD_D1,"!LinRegrBuf","true",barstocount,1,0);
   double slopeD1=((D1_resistance-D1_resistance_p)/barstocount)/Point;    
   
   //W1
   double W1_resistance=iCustom(NULL,PERIOD_W1,"!LinRegrBuf","true",barstocount,2,0);
   double W1_resistance_p=iCustom(NULL,PERIOD_W1,"!LinRegrBuf","true",barstocount,2,barstocount-1);
   double W1_line=iCustom(NULL,PERIOD_W1,"!LinRegrBuf","true",barstocount,0,0);
   double W1_support=iCustom(NULL,PERIOD_W1,"!LinRegrBuf","true",barstocount,1,0);
   double slopeW1=((W1_resistance-W1_resistance_p)/barstocount)/Point;     
   
   //MN1
   double MN1_resistance=iCustom(NULL,PERIOD_MN1,"!LinRegrBuf","true",barstocount,2,0);
   double MN1_resistance_p=iCustom(NULL,PERIOD_MN1,"!LinRegrBuf","true",barstocount,2,barstocount-1);
   double MN1_line=iCustom(NULL,PERIOD_MN1,"!LinRegrBuf","true",barstocount,0,0);
   double MN1_support=iCustom(NULL,PERIOD_MN1,"!LinRegrBuf","true",barstocount,1,0);
   double slopeMN1=((MN1_resistance-MN1_resistance_p)/barstocount)/Point;        
   
   //Alert(DoubleToStr(slopeM1,2)+" "+DoubleToStr(slopeM5,2)+" "+DoubleToStr(slopeM15,2)+" "+DoubleToStr(slopeM30,2)+" "+DoubleToStr(slopeH1,2));   
/*   
   Comment(
   "\n","M1  Slope | ",slopeM1,
   "\n","M5  Slope | ",slopeM5,
   "\n","M15 Slope | ",slopeM15,
   "\n","M30 Slope | ",slopeM30,
   "\n","H1  Slope | ",slopeH1,
   "\n","H4  Slope | ",slopeH4,
   "\n","D1  Slope | ",slopeD1,
   "\n","W1  Slope | ",slopeW1,
   "\n","MN1 Slope | ",slopeMN1);//M1_resistance,"\n",M1_resistance_p
*/  


Comment( "Waiting..." ) ;  

  //SHORT ENTRY
  if(slopeH1<0  )
  {     
         double M5High=iHigh(Symbol(),PERIOD_M5,0);
         if(M5High>=M5_resistance)
              {
               double M1High=iHigh(Symbol(),PERIOD_M1,0);
               if(M1High>=M1_resistance)
               {
                    Comment( "Short Entry H1" ) ;  
               }
         }
  } 
 
  
  //LONG ENTRY
  if(slopeH1>0 && IsTradeAllowed()==true)
  {
    
     double M5Low=iLow(Symbol(),PERIOD_M5,0);
     if(M5Low<=M5_support)
       {
        double M1Low=iLow(Symbol(),PERIOD_M1,0);
        if(M1Low<=M1_support)
          { 
            Comment( "Long Entry H1" ) ;
          }
       }
   }

   
   

   return(0);
}
//+------------------------------------------------------------------+