//+------------------------------------------------------------------+
//|                                                   TrendAlert.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window

#property  indicator_buffers 2
#property indicator_color1 Yellow      
#property indicator_color2 Aqua

double ExtMapBuffer0[];
double ExtMapBuffer1[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexBuffer(0,ExtMapBuffer0);
   SetIndexBuffer(1,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);   
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
 
//----
   double A, B;
   
  int limit;
   int counted_bars = IndicatorCounted();
   //---- check for possible errors
   if (counted_bars<0) return(-1);
   //---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   limit = Bars - counted_bars;

   for(int i=limit; i>=0; i--)
   {   
      A=iStdDev(Symbol(),30,20,0,MODE_SMA,PRICE_CLOSE,i);
      B=iStdDev(Symbol(),30,20,0,MODE_SMA,PRICE_CLOSE,i+1);
      ExtMapBuffer0[i] = A ;
      ExtMapBuffer1[i] = B ;   
   }
   
   
   if (A>B) {PlaySound("Alert2.wav");}
//   Comment("Trend Alert Designed by forexlion, Trade only when alarm is ringing");
//----
   return(0);
  }
//+------------------------------------------------------------------+